#!/bin/sh

# be sure to have all build deps + libtool installed before running this

set -e

if [ -z "$1" -o $# -ne 1 ]; then
  echo "Usage: $0 <xine-lib-version>"
  exit 2
fi

version=$1

# missing dependency on autoconf >= (apparently) 2.61 in upstream autofoo files
acversion="$(rpm -q --qf=%{VERSION} autoconf)"
case $acversion in
    2.6*) ;;
    *) echo "ERROR: autoconf >= 2.61 required" ; exit 1 ;;
esac

rm -rf xine-lib-$version xine-lib-$version-pruned
tar jxf xine-lib-$version-pruned.tar.bz2
cp -a xine-lib-$version xine-lib-$version-pruned

cd xine-lib-$version
./autogen.sh noconfig
rm -rf autom4te.cache *~
cd ..

diff -Nru xine-lib-$version-pruned xine-lib-$version \
| bzip2 --best > xine-lib-$version-autotools.patch.bz2
